SFML

- Main Page
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
sf::RenderTexture Class Reference
Graphics module

Target for off-screen 2D rendering into a texture. More...

`#include <RenderTexture.hpp>`

Inheritance diagram for sf::RenderTexture:

## Public Member Functions
| RenderTexture ()
| Default constructor. More...
virtual | ~RenderTexture ()
| Destructor. More...
bool | create (unsigned int width, unsigned int height, bool depthBuffer=false)
| Create the render-texture. More...
void | setSmooth (bool smooth)
| Enable or disable texture smoothing. More...
bool | isSmooth () const
| Tell whether the smooth filtering is enabled or not. More...
void | setRepeated (bool repeated)
| Enable or disable texture repeating. More...
bool | isRepeated () const
| Tell whether the texture is repeated or not. More...
bool | setActive (bool active=true)
| Activate of deactivate the render-texture for rendering. More...
void | display ()
| Update the contents of the target texture. More...
virtual Vector2u | getSize () const
| Return the size of the rendering region of the texture. More...
const Texture & | getTexture () const
| Get a read-only reference to the target texture. More...
void | clear (const Color &color=Color(0, 0, 0, 255))
| Clear the entire target with a single color. More...
void | setView (const View &view)
| Change the current active view. More...
const View & | getView () const
| Get the view currently in use in the render target. More...
const View & | getDefaultView () const
| Get the default view of the render target. More...
IntRect | getViewport (const View &view) const
| Get the viewport of a view, applied to this render target. More...
Vector2f | mapPixelToCoords (const Vector2i &point) const
| Convert a point from target coordinates to world coordinates, using the current view. More...
Vector2f | mapPixelToCoords (const Vector2i &point, const View &view) const
| Convert a point from target coordinates to world coordinates. More...
Vector2i | mapCoordsToPixel (const Vector2f &point) const
| Convert a point from world coordinates to target coordinates, using the current view. More...
Vector2i | mapCoordsToPixel (const Vector2f &point, const View &view) const
| Convert a point from world coordinates to target coordinates. More...
void | draw (const Drawable &drawable, const RenderStates &states=RenderStates::Default)
| Draw a drawable object to the render-target. More...
void | draw (const Vertex *vertices, unsigned int vertexCount, PrimitiveType type, const RenderStates &states=RenderStates::Default)
| Draw primitives defined by an array of vertices. More...
void | pushGLStates ()
| Save the current OpenGL render states and matrices. More...
void | popGLStates ()
| Restore the previously saved OpenGL render states and matrices. More...
void | resetGLStates ()
| Reset the internal OpenGL states so that the target is ready for drawing. More...

## Protected Member Functions
void | initialize ()
| Performs the common initialization step after creation. More...

## Detailed Description

Target for off-screen 2D rendering into a texture.

sf::RenderTexture is the little brother of sf::RenderWindow.

It implements the same 2D drawing and OpenGL-related functions (see their base class sf::RenderTarget for more details), the difference is that the result is stored in an off-screen texture rather than being show in a window.

Rendering to a texture can be useful in a variety of situations:

- precomputing a complex static texture (like a level's background from multiple tiles)
- applying post-effects to the whole scene with shaders
- creating a sprite from a 3D object rendered with OpenGL
- etc.

Usage example:

// Create a new render-window
sf::RenderWindow window(sf::VideoMode(800, 600), "SFML window");
// Create a new render-texture
sf::RenderTexture texture;
if (!texture.create(500, 500))
return -1;
// The main loop
while (window.isOpen())
{
// Event processing
// ...
// Clear the whole texture with red color
texture.clear(sf::Color::Red);
// Draw stuff to the texture
texture.draw(sprite); // sprite is a sf::Sprite
texture.draw(shape); // shape is a sf::Shape
texture.draw(text); // text is a sf::Text
// We're done drawing to the texture
texture.display();
// Now we start rendering to the window, clear it first
window.clear();
// Draw the texture
sf::Sprite sprite(texture.getTexture());
window.draw(sprite);
// End the current frame and display its contents on screen
window.display();
}

Like sf::RenderWindow, sf::RenderTexture is still able to render direct OpenGL stuff. It is even possible to mix together OpenGL calls and regular SFML drawing commands. If you need a depth buffer for 3D rendering, don't forget to request it when calling RenderTexture::create.

See Also
  sf::RenderTarget, sf::RenderWindow, sf::View, sf::Texture

Definition at line 47 of file RenderTexture.hpp.

## Constructor & Destructor Documentation

sf::RenderTexture::RenderTexture | ( | ) |  |

Default constructor.

Constructs an empty, invalid render-texture. You must call create to have a valid render-texture.

See Also
  create

virtual sf::RenderTexture::~RenderTexture | ( | ) |  |
| virtual

Destructor.

## Member Function Documentation

void sf::RenderTarget::clear | ( | const Color & | color = `Color(0, 0, 0, 255)`) |  |
| inherited

Clear the entire target with a single color.

This function is usually called once every frame, to clear the previous contents of the target.

Parameters

  color | Fill color to use to clear the render target

bool sf::RenderTexture::create | ( | unsigned int | width,
|  | unsigned int | height,
|  | bool | depthBuffer = `false`
| ) |  |

Create the render-texture.

Before calling this function, the render-texture is in an invalid state, thus it is mandatory to call it before doing anything with the render-texture. The last parameter, depthBuffer, is useful if you want to use the render-texture for 3D OpenGL rendering that requires a depth-buffer. Otherwise it is unnecessary, and you should leave this parameter to false (which is its default value).

Parameters

  width | Width of the render-texture
  height | Height of the render-texture
  depthBuffer | Do you want this render-texture to have a depth buffer?

Returns
  True if creation has been successful

void sf::RenderTexture::display | ( | ) |  |

Update the contents of the target texture.

This function updates the target texture with what has been drawn so far. Like for windows, calling this function is mandatory at the end of rendering. Not calling it may leave the texture in an undefined state.

void sf::RenderTarget::draw | ( | const Drawable & | drawable,
|  | const RenderStates & | states = `RenderStates::Default`
| ) |  |
| inherited

Draw a drawable object to the render-target.

Parameters

  drawable | Object to draw
  states | Render states to use for drawing

void sf::RenderTarget::draw | ( | const Vertex * | vertices,
|  | unsigned int | vertexCount,
|  | PrimitiveType | type,
|  | const RenderStates & | states = `RenderStates::Default`
| ) |  |
| inherited

Draw primitives defined by an array of vertices.

Parameters

  vertices | Pointer to the vertices
  vertexCount | Number of vertices in the array
  type | Type of primitives to draw
  states | Render states to use for drawing

const View& sf::RenderTarget::getDefaultView | ( | ) |  | const
| inherited

Get the default view of the render target.

The default view has the initial size of the render target, and never changes after the target has been created.

Returns
  The default view of the render target

See Also
  setView, getView

virtual Vector2u sf::RenderTexture::getSize | ( | ) |  | const
| virtual

Return the size of the rendering region of the texture.

The returned value is the size that you passed to the create function.

Returns
  Size in pixels

Implements sf::RenderTarget.

const Texture& sf::RenderTexture::getTexture | ( | ) |  | const

Get a read-only reference to the target texture.

After drawing to the render-texture and calling Display, you can retrieve the updated texture using this function, and draw it using a sprite (for example). The internal sf::Texture of a render-texture is always the same instance, so that it is possible to call this function once and keep a reference to the texture even after it is modified.

Returns
  Const reference to the texture

const View& sf::RenderTarget::getView | ( | ) |  | const
| inherited

Get the view currently in use in the render target.

Returns
  The view object that is currently used

See Also
  setView, getDefaultView

IntRect sf::RenderTarget::getViewport | ( | const View & | view) |  | const
| inherited

Get the viewport of a view, applied to this render target.

The viewport is defined in the view as a ratio, this function simply applies this ratio to the current dimensions of the render target to calculate the pixels rectangle that the viewport actually covers in the target.

Parameters

  view | The view for which we want to compute the viewport

Returns
  Viewport rectangle, expressed in pixels

void sf::RenderTarget::initialize | ( | ) |  |
| protected inherited

Performs the common initialization step after creation.

The derived classes must call this function after the target is created and ready for drawing.

bool sf::RenderTexture::isRepeated | ( | ) |  | const

Tell whether the texture is repeated or not.

Returns
  True if texture is repeated

See Also
  setRepeated

bool sf::RenderTexture::isSmooth | ( | ) |  | const

Tell whether the smooth filtering is enabled or not.

Returns
  True if texture smoothing is enabled

See Also
  setSmooth

Vector2i sf::RenderTarget::mapCoordsToPixel | ( | const Vector2f & | point) |  | const
| inherited

Convert a point from world coordinates to target coordinates, using the current view.

This function is an overload of the mapCoordsToPixel function that implicitely uses the current view. It is equivalent to:

target.mapCoordsToPixel(point, target.getView());

Parameters

  point | Point to convert

Returns
  The converted point, in target coordinates (pixels)

See Also
  mapPixelToCoords

Vector2i sf::RenderTarget::mapCoordsToPixel | ( | const Vector2f & | point,
|  | const View & | view
| ) |  | const
| inherited

Convert a point from world coordinates to target coordinates.

This function finds the pixel of the render-target that matches the given 2D point. In other words, it goes through the same process as the graphics card, to compute the final position of a rendered point.

Initially, both coordinate systems (world units and target pixels) match perfectly. But if you define a custom view or resize your render-target, this assertion is not true anymore, ie. a point located at (150, 75) in your 2D world may map to the pixel (10, 50) of your render-target – if the view is translated by (140, 25).

This version uses a custom view for calculations, see the other overload of the function if you want to use the current view of the render-target.

Parameters

  point | Point to convert
  view | The view to use for converting the point

Returns
  The converted point, in target coordinates (pixels)

See Also
  mapPixelToCoords

Vector2f sf::RenderTarget::mapPixelToCoords | ( | const Vector2i & | point) |  | const
| inherited

Convert a point from target coordinates to world coordinates, using the current view.

This function is an overload of the mapPixelToCoords function that implicitely uses the current view. It is equivalent to:

target.mapPixelToCoords(point, target.getView());

Parameters

  point | Pixel to convert

Returns
  The converted point, in "world" coordinates

See Also
  mapCoordsToPixel

Vector2f sf::RenderTarget::mapPixelToCoords | ( | const Vector2i & | point,
|  | const View & | view
| ) |  | const
| inherited

Convert a point from target coordinates to world coordinates.

This function finds the 2D position that matches the given pixel of the render-target. In other words, it does the inverse of what the graphics card does, to find the initial position of a rendered pixel.

Initially, both coordinate systems (world units and target pixels) match perfectly. But if you define a custom view or resize your render-target, this assertion is not true anymore, ie. a point located at (10, 50) in your render-target may map to the point (150, 75) in your 2D world – if the view is translated by (140, 25).

For render-windows, this function is typically used to find which point (or object) is located below the mouse cursor.

This version uses a custom view for calculations, see the other overload of the function if you want to use the current view of the render-target.

Parameters

  point | Pixel to convert
  view | The view to use for converting the point

Returns
  The converted point, in "world" units

See Also
  mapCoordsToPixel

void sf::RenderTarget::popGLStates | ( | ) |  |
| inherited

Restore the previously saved OpenGL render states and matrices.

See the description of pushGLStates to get a detailed description of these functions.

See Also
  pushGLStates

void sf::RenderTarget::pushGLStates | ( | ) |  |
| inherited

Save the current OpenGL render states and matrices.

This function can be used when you mix SFML drawing and direct OpenGL rendering. Combined with PopGLStates, it ensures that:

- SFML's internal states are not messed up by your OpenGL code
- your OpenGL states are not modified by a call to a SFML function

More specifically, it must be used around code that calls Draw functions. Example:

// OpenGL code here...
window.pushGLStates();
window.draw(...);
window.draw(...);
window.popGLStates();
// OpenGL code here...

Note that this function is quite expensive: it saves all the possible OpenGL states and matrices, even the ones you don't care about. Therefore it should be used wisely. It is provided for convenience, but the best results will be achieved if you handle OpenGL states yourself (because you know which states have really changed, and need to be saved and restored). Take a look at the ResetGLStates function if you do so.

See Also
  popGLStates

void sf::RenderTarget::resetGLStates | ( | ) |  |
| inherited

Reset the internal OpenGL states so that the target is ready for drawing.

This function can be used when you mix SFML drawing and direct OpenGL rendering, if you choose not to use pushGLStates/popGLStates. It makes sure that all OpenGL states needed by SFML are set, so that subsequent draw() calls will work as expected.

Example:

// OpenGL code here...
glPushAttrib(...);
window.resetGLStates();
window.draw(...);
window.draw(...);
glPopAttrib(...);
// OpenGL code here...

bool sf::RenderTexture::setActive | ( | bool | active = `true`) |  |

Activate of deactivate the render-texture for rendering.

This function makes the render-texture's context current for future OpenGL rendering operations (so you shouldn't care about it if you're not doing direct OpenGL stuff). Only one context can be current in a thread, so if you want to draw OpenGL geometry to another render target (like a RenderWindow) don't forget to activate it again.

Parameters

  active | True to activate, false to deactivate

Returns
  True if operation was successful, false otherwise

void sf::RenderTexture::setRepeated | ( | bool | repeated) |  |

Enable or disable texture repeating.

This function is similar to Texture::setRepeated. This parameter is disabled by default.

Parameters

  repeated | True to enable repeating, false to disable it

See Also
  isRepeated

void sf::RenderTexture::setSmooth | ( | bool | smooth) |  |

Enable or disable texture smoothing.

This function is similar to Texture::setSmooth. This parameter is disabled by default.

Parameters

  smooth | True to enable smoothing, false to disable it

See Also
  isSmooth

void sf::RenderTarget::setView | ( | const View & | view) |  |
| inherited

Change the current active view.

The view is like a 2D camera, it controls which part of the 2D scene is visible, and how it is viewed in the render-target. The new view will affect everything that is drawn, until another view is set. The render target keeps its own copy of the view object, so it is not necessary to keep the original one alive after calling this function. To restore the original view of the target, you can pass the result of getDefaultView() to this function.

Parameters

  view | New view to use

See Also
  getView, getDefaultView

The documentation for this class was generated from the following file:

- RenderTexture.hpp